# include <gtk/gtk.h>
# include <stdlib.h>
# include <glib/gprintf.h>

# include <gtk_lib.h>
# include <anime.h>
# include <unit.h>
# include <map.h>
# include <system.h>

GtkWidget *window;
GdkPixmap *pixmap;
myAnimeArea *area;
Map *map;
// int map_life = 10;
// int money = 100;

gint select_unit = 0; /* クリックするとこの番号の味方を出す(佐藤) */

int map_position[4][4] = {};

void map_init(void)
{
	map = (Map *)malloc(sizeof(Map));
	window = my_window_new(WINDOW_WIDTH, WINDOW_HEIGHT);
	pixmap = my_pixmap_new_from_data(window, "../data/map.jpg");
	area = my_anime_area_new(WINDOW_WIDTH, WINDOW_HEIGHT, pixmap, INTERVAL);
}

void map_collision(myAnimeArea* area, int event_x, int event_y)
{
	gint unit_x, unit_y;

	map->x = event_x / DIVIDE_SIZE; 
	map->y = event_y / DIVIDE_SIZE;
	if ( map->y == 0 || map->y == 2 ){
      switch( map_position[map->x][map->y] ){
      case EMPTY:
        if( g_system->money >= unit_type[select_unit].cost ){
          g_system->money -= unit_type[select_unit].cost;
          system_draw(g_system->life, g_system->money, FALSE, 1);

          unit_x = (gint)(DIVIDE_SIZE * (map->x + 0.5));
          unit_y = (gint)(DIVIDE_SIZE * (map->y + 0.5));
          unit_new(area, unit_x, unit_y, select_unit);
          map_position[map->x][map->y] = EXIST;
        }
        else{
          play_se("../data/shortage.wav");
        }
        break;
      case EXIST:
        unit_delete(event_x, event_y);
        map_position[map->x][map->y] = EMPTY;
        break;
      default:
        printf("******* ERROR IN FUNC map_collision ******\n");
      }
    }
}

// void map_load_file(void)
// {
// }
